import type { BasicRule } from './rules/utils';
import { RequestRule } from './rules/RequestRule';
import { NoFilteringRule } from './rules/NoFilteringRule';
import { Comment } from './rules/Comment';
import { CustomRule } from './rules/CustomRule';
import { DNSRule } from './rules/DNSRule';
declare const isValidDomain: any;
export type RuleType = 'block' | 'unblock' | 'noFiltering' | 'custom' | 'comment';
type DomainValidationOptions = Parameters<typeof isValidDomain>[1];
export declare class RulesBuilder {
    static getRuleByType(type: 'block'): RequestRule;
    static getRuleByType(type: 'unblock'): RequestRule;
    static getRuleByType(type: 'noFiltering'): NoFilteringRule;
    static getRuleByType(type: 'custom'): CustomRule;
    static getRuleByType(type: 'comment'): Comment;
    static getDnsRule(isBlockingRule: boolean): DNSRule;
    static validateDomain(ruleBuilder: RequestRule | NoFilteringRule, opts?: DomainValidationOptions): any;
    static validateRule(ruleBuilder: BasicRule): boolean;
    static getRuleType(rawRule: string, isDnsRule?: boolean): RuleType | null;
    static getRuleFromRuleString(rawRule: string, isDnsRule?: boolean): RequestRule | NoFilteringRule | CustomRule | Comment | DNSRule | null;
}
export {};
