import type { BasicRule } from './utils';
import { DomainModifiers, ContentTypeModifiers } from './utils';
export declare class RequestRule implements BasicRule {
    private domain;
    private contentModifiers;
    private isBlockingRule;
    private domainModifier;
    private domainModifierDomains;
    private important;
    constructor(isBlockingRule: boolean);
    setDomain(domain: string): void;
    getDomain(): string;
    setContentType(modifiers: ContentTypeModifiers[]): void;
    setDomainModifiers(modifier: DomainModifiers, domains?: string[]): void;
    setHighPriority(priority: boolean): void;
    getContentType(): ContentTypeModifiers[];
    getDomainModifiers(): DomainModifiers;
    getDomainModifiersDomains(): string[];
    getHighPriority(): boolean;
    buildRule(): string;
    static fromRule(rawRule: string, isBlockingRule: boolean): RequestRule;
}
